#!/usr/bin/env python
# -*- coding: utf-8 -*-

# fit 1.0
# descr: used to fill your dvds with good stuff (distfiles for example)
# my first python app ever, so it's probably crap. i don't dare inspect it anymore.
# Copyright (C) 2003 Niklas Lundberg ( niklas(_at_)jahej(_dot_)com subject fit.py )
# For you non-laywers out there, this practically means that if you have some
# cool improvements or bugfixes or just some feature you would like to see added
# or perhaps you already added it, send me a patch file or a description and I will
# incorporate it a.s.a.p. and put up a new version on the web.

## This program is free software; you can redistribute it and/or
## modify it under the terms of the GNU General Public License
## as published by the Free Software Foundation; either version 2
## of the License, or (at your option) any later version.

## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

# http://www.gnu.org/licenses/gpl.html

# if elements are small...
# then i suggest not going over 22 elements = 30seconds
# 23 elems = 50 seconds to 4 mins. 400 mb ram
# just some random stats, just be careful! your cpu might overheat!
import sys
import os
import stat
import getopt

verbose = False
def dprint(x):
    if verbose:
        print x

def sizeof(path):
    mode = os.stat(path)[stat.ST_MODE]

    if stat.S_ISLNK(mode):
        return sizeof(os.readlink(a))

    if stat.S_ISDIR(mode):
        sum = os.stat(path)[stat.ST_SIZE]
        for e in os.listdir(path):
            sum += sizeof( os.path.join(path,e) )
        return sum

    if stat.S_ISREG(mode):
        return os.stat(path)[stat.ST_SIZE]

    # Unknown file type, print a message
    print('Skipping %s' % path)
    return 0


#takes a list sorted by size with largest first and...
def remove_too_big_entries(sizels, size):
    if len(sizels) == 0:
        return []
    if sizels[0][0] > size:
        print("removing %s (too big)" % sizels[0])
        return remove_too_big_entries(sizels[1:], size)
    else:
        return sizels

def usage():
    print "you need help!"
    print "run this with a list of dirs and files as arguments, no args will try ./*"
    print "example: fit.py file1 file2 dir1 dir2 file3 dir3"
    print "-v --verbose"
    print "-s --skip-biggest (or the biggest entry is forced to join the result)"
    print "-h --help"
    print "-t --target-size= (if you want something else than the default of 4700000000 bytes (dvd), like cd perhaps?"


# returns lists with combinations and slackspace that dont exceed the targetsize
def all_combos(donels, todols, targetsize):
    if targetsize < 0: # oops, exceeded size, bail out
        return []

    if len(todols) == 0:
        return [[targetsize, donels]] # targetsize is now how much slack space we ended up with

    return all_combos(donels, todols[1:], targetsize) + all_combos(donels + [todols[0]], todols[1:], targetsize - todols[0][0])


def fit(sizels, targetsize):
    return all_combos([], sizels, targetsize)

if __name__ == '__main__':
    try:
        opts, args = getopt.getopt(sys.argv[1:], "hvst:", ["help", "verbose", "skip-biggest", "targetsize="])
    except getopt.GetoptError:
        usage()
        sys.exit(2)

    #default option values
    #targetsize = 4700000000 # dvd
    targetsize = 4600000000
    #targetsize = 4650000000
    require_biggest_file = True

    for o,a in opts:
        if o in ("-v", "--verbose"):
            verbose = True
        if o in ("-s", "--skip-biggest"):
           require_biggest_file  = False
        if o in ("-h", "--help"):
            usage()
            sys.exit()
        if o in ("-t", "--targetsize"):
            targetsize = a


    if len(args) != 0:
        ls = args
    else:
        ls = os.listdir(".")

    dprint( "stuff to process: %s" % ls)

    sizels = []

    for a in ls:
        s = sizeof(a)
        #print s, a
        sizels.append( [s,a] )

    dprint( "sizes collected: %s" % sizels)

    size=0
    for a in sizels:
        size += a[0]

    dprint( "total: %s" % size)

    sizels.sort()
    sizels.reverse()
    print "input: (len %s)" % len(sizels)
    for a in sizels:
        print a[0], a[1]

    sizels = remove_too_big_entries(sizels, targetsize)
    if len(sizels) == 0:
        print "meh! nothing fits :("
        sys.exit()


    if len(sizels) == 1:
        print "only element: ", sizels[0]
        sys.exit()

    print "teh winnar si:"
    if require_biggest_file:
        print sizels[0][1],
        newtargetsize = targetsize - sizels[0][0]
        ls = fit(sizels[1:], newtargetsize)
    else:
        newtargetsize = targetsize
        ls = fit(sizels, newtargetsize)

    #print "list is: (len %s)" % len(ls)
    #for a in ls:
    #    print a


    best = [newtargetsize, []]
    for a in ls:
        if a[0] < best[0]:
            best = a

    for a in best[1]:
        print a[1],

    print
    print "size:", (targetsize - best[0])/1024/1024, "MB. (", targetsize - best[0], "bytes). Slack space:", best[0], "bytes (", best[0]/1024/1024, "MB)"

